from Node import Node
from string import ascii_lowercase

# Faster to use a set as it is O(1) time to check if it contains a word
valid_words = set()

'''
Group: Theo is sick
In our TestGame.py we improved the BFS speed by 
using a deque for todo and a set for visisted.
'''

def read_dictionary(filename, length):
    global valid_words
    valid_words = set() # Reset valid_words
    
    length = int(length)
    # Read in the dictionary
    with open(filename) as f:
    	for w in f:
    		if len(w.strip()) == length and all(char.islower() for char in w.strip()):
    			valid_words.add(w.strip())


class WordGameNode(Node):
    def __init__(self, name, parent=None):
        # Ensure lowercase letters (no digits or special chars)
        for letter in name:
            assert letter in ascii_lowercase

        self.name = name
        self.parent = parent

        self.valid_words = None

    def __str__(self):
        return self.name

    def __lt__(self, other):
        return self.name < other.name

    def get_children(self):
        # all one letter mutations of the word
        global valid_words
        child_words = []
        i = 0
        for letter in self.name:
            for char in ascii_lowercase:
                if char != letter:
                    word = self.name[:i] + char + self.name[i + 1:]
                    if word in valid_words and word != self.name:
                    	# Make a new WordGameNode with this node as its parent, and add it to child_words
                        child_words.append(WordGameNode(word, self))
            i += 1
        return child_words

    def get_path(self):
        path = [self]
        while self.parent is not None:
            path.append(self.parent)
            self = self.parent

        return path
